/***************************************************************************
                          dialegfourier.cpp  -  description
                             -------------------
    begin                : vie nov 21 2003
    copyright            : (C) 2003 by projecte
    email                : projecte@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dialegfourier.h"

DialegFourier::DialegFourier(Imatge &i,  QList<CaractDoc> &pDocList, int area, char *inicial):QDialog (0, 0, FALSE, WStyle_Customize | WType_Dialog | WStyle_Title | WStyle_DialogBorder){
  bool accepta;
  //incialtizem la memoria dinamica
  formaF=NULL;
  f=NULL;
  
  CANCELAR=false;
  totals=0;
  afegir=false;
  this->area=area;
  this->inicial=inicial;
  conta=0;
     

  pDoc=&pDocList;    //referencia a la llista de pDocList
  img=&i;                  //referencia a la imatge


  img->RecorreAntihorari();

  
  setFixedSize (650,390);

  setCaption("Metode de Fourier");
  accepta = Inicialitza();
  if (!accepta) close();
}
                                                            /*
void DialegFourier::Afegeix_en_silenci (){


}                                                         */


void DialegFourier::InitDialeg (Imatge &i,  QList<CaractDoc> &pDocList, int area, char *inicial){
  CaractDoc *tmp;
  QString fileName, s;
  int j=1;
  
  //incialtizem la memoria dinamica
  if (formaF!=NULL){
   delete formaF;
   formaF=NULL;
  }

  if (f!=NULL){
   delete f;
   f=NULL;
  }

  //esborrem la llista de finestres
  Finestres->clear();
  conta=0;
  
  for ( tmp = pDoc->first(); tmp; tmp = pDoc->next() ){
   fileName=QString(tmp->title());
   fileName = fileName.section( '/', -1 );    //agafa unicament el nom
   Finestres->insertItem(fileName);
  }

  CANCELAR=false;
  totals=0;
  afegir=false;
  this->area=area;
  this->inicial=inicial;


  pDoc=&pDocList;    //referencia a la llista de pDocList
  img=&i;                  //referencia a la imatge


  img->RecorreAntihorari();

  //Desactivem les altres caracteristiques
  GrupCaract->setDisabled (FALSE);
    OpcioArea->setChecked(FALSE);
    OpcioPerimetre->setChecked(FALSE);
    OpcioMinRectangle->setChecked(FALSE);
    OpcioCompactnes->setChecked(FALSE);
    OpcioLength->setChecked(FALSE);
    OpcioBreadth->setChecked(FALSE);
    OpcioElongation->setChecked(FALSE);
    OpcioCentreGravetat->setChecked(FALSE);

  GrupMetode->setDisabled (FALSE);
   OpcioFourier1->setChecked (TRUE);
   OpcioFFT->setChecked (TRUE);
   OpcioFFT->setDisabled (FALSE);
   OpcioEquidistants->setChecked (TRUE);
   OpcioEquidistants->setDisabled (FALSE);

  GrupReconeixement->setDisabled (FALSE);
   OpcioCBIR->setChecked (FALSE);
   OpcioRec->setChecked (FALSE);
   OpcioRecFF->setChecked (FALSE);
   OpcioRecFF->setDisabled (true);

  GrupBD->setDisabled (FALSE);
    nom->setText (inicial);

  GrupTipus1->setDisabled(true);
   OpcioFurqui1->setChecked(false);
   OpcioMamo1->setChecked (false);
   OpcioSintet1->setChecked (false);
  GrupTipus2->setDisabled(true);
   OpcioFurqui2->setChecked(false);
   OpcioMamo2->setChecked (false);
   OpcioSintet2->setChecked (false);
  GrupTipus->setDisabled(TRUE);
   OpcioFurqui->setChecked(false);
   OpcioMamo->setChecked (false);
   OpcioSintet->setChecked (false);

  OpcioComparar->setDisabled (FALSE);
  OpcioComparar->setChecked (FALSE);

  while (j <= img->contorn->perimetre)    //Total de mostres a agafar
   j*=2;

  EntradaPas->setText (s.setNum(j));
  OpcioAfegeix->setChecked(false);
/// LINIA K SOBRA !!!!
/*
OpcioAfegeix->setChecked (true);
  slotUpdateAfegeix(2);
  EntradaPas->setText (s.setNum(512));
  OpcioFourier2->setChecked(true);                    */
}                                                                          


DialegFourier::~DialegFourier(){
  if (formaF!=NULL)
   delete formaF;

  if (f!=NULL)
   delete f;
   

  delete botoOk;
  delete botoCancel;


  delete GrupMetode;
     delete OpcioFourier1;
     delete OpcioFourier2;


     delete OpcioEquidistants;
     delete OpcioFFT;
     delete EntradaPas;
     delete Etiqueta;


  delete GrupCaract;
      delete OpcioArea;
      delete OpcioPerimetre;
      delete OpcioMinRectangle;
      delete OpcioCompactnes;
      delete OpcioLength;
      delete OpcioBreadth;
      delete OpcioElongation;
      delete OpcioCentreGravetat;


  delete GrupBD;
      delete OpcioAfegeix;
      delete EtiquetaNom;
      delete nom;    

  delete Finestres;
      delete OpcioComparar;


  delete GrupReconeixement;
      delete OpcioRec;
      delete OpcioCBIR;
      delete MesSemblants;
      delete OpcioRecFF;

   delete GrupTipus;      //Opcions omplir BD
      delete OpcioMamo;
      delete OpcioSintet;
      delete OpcioFurqui;



   delete GrupTipus1;   //Opcions Consultar BD
      delete OpcioMamo1;
      delete OpcioSintet1;
      delete OpcioFurqui1;


   delete GrupTipus2;   
      delete OpcioMamo2;
      delete OpcioSintet2;
      delete OpcioFurqui2;
}



void DialegFourier::slotBotoCANCEL(){
  CANCELAR=true;
  close();
}

void DialegFourier::slotBotoOK(){
   QString tmp;

   if (!OpcioComparar->isChecked()){    //no comparem ni afegim a la BD  --> calculem en viu
      COMPARAR=false;
      if (!OpcioEquidistants->isChecked()){  //NO han de ser equidistants
         if (OpcioFourier1->isChecked()){      //Retorna complexes
            tmp="_________________________________<BR>";
            tmp+="FOURIER  :  COORDENADA COMPLEXE<BR>";
            tmp+="\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257<BR>";

  
            formaF = new Fourier(*img,-1);

            formaF->Fourier1(*img);
            tmp+=formaF->MostraPunts(*img);

            img->dw->Text.setText(tmp);

            close();
            tmp+=AltresCaracteristiques(*img);
            img->dw->Text.setText(tmp);
            }
         else if (OpcioFourier2->isChecked()){
            formaF = new Fourier(*img,-1);
            tmp="______________________________<BR>";
            tmp+="FOURIER  :  DISTANCIA AL CENTRE<BR>";
            tmp+="\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257<BR>";
            

            formaF->Fourier2(*img);


            tmp+=formaF->MostraPunts(*img);
            img->dw->Text.setText(tmp);

            close();
            tmp+=AltresCaracteristiques(*img);
            img->dw->Text.setText(tmp);
         }
      }
      else{    //han de ser equidistants
         if (OpcioFourier1->isChecked()){      //Retorna complexes
            QString s;
            bool ha_nat;
            int d;


            s=EntradaPas->text();
            d=s.toInt(&ha_nat);

            if (!ha_nat)
               EntradaPas->validateAndSet ( "ERROR", 0, 0, 5);
            else if (OpcioFFT->isChecked()){
               if (d & (d-1)) //truco per mirar si es potencia d 2
                  EntradaPas->validateAndSet ( "Potencia de 2 !", 0, 0, 15);
            }

            if ((!(d & (d-1)) || !OpcioFFT->isChecked()) && ha_nat){
              tmp="_________________________________<BR>";
              tmp+="FOURIER  :  COORDENADA COMPLEXE<BR>";
              tmp+="\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257<BR>";
               

              formaF = new Fourier(*img,d);

               formaF->Fourier1Equi(*img, OpcioFFT->isChecked());

               tmp+=formaF->MostraPunts(*img);

               img->dw->Text.setText(tmp);
               close();
               tmp+=AltresCaracteristiques(*img);
               img->dw->Text.setText(tmp);
               }
            }
         else if (OpcioFourier2->isChecked()){
            QString s;
            bool ha_nat;
            int d;

            s=EntradaPas->text();
            d=s.toInt(&ha_nat);

            if (!ha_nat)
               EntradaPas->validateAndSet ( "ERROR", 0, 0, 5);
            else if (OpcioFFT->isChecked()){
               if (d & (d-1))
                  EntradaPas->validateAndSet ( "Potencia de 2 !", 0, 0, 15);
            }

            if ((!(d & (d-1)) || !OpcioFFT->isChecked()) && ha_nat){
               formaF = new Fourier(*img,d);
               tmp="______________________________<BR>";
               tmp+="FOURIER  :  DISTANCIA AL CENTRE<BR>";
               tmp+="\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257<BR>";

            



               formaF->Fourier2Equi(*img, OpcioFFT->isChecked());
               tmp+=formaF->MostraPunts(*img);
               img->dw->Text.setText(tmp);

               close();
               tmp+=AltresCaracteristiques(*img);
               img->dw->Text.setText(tmp);

            }
         }
      }

//      if (OpcioRec->isChecked()){ //volem consultar a Reconeixement

//      }
      if (OpcioAfegeix->isChecked())   //AFEGIM A LA BD
         afegir=true;
   }
   else{                                             // HEM DE COMPARAR DOS IMATGES
      int conta, selec=0, i=0;
      //ens assegurme k tinguem 2 imatges seleccionades
      conta=Finestres->count();
      while (i<conta){
      if (Finestres->isSelected(i)){
         selec++;
      }
      i++;
      }
      if (selec==2){
         COMPARAR=true;
         Imatge *imat[2];  //les dos imatges seleccionaes
         int imatPos[2];     //posicio a la llista de docs de les imatges selecionades
         int k=0, l=0, total_finestres;
         Imatge imtmp;
         QString s, fileName;
         CaractDoc *doc2 = new CaractDoc();
         CaractDoc *doc3 = new CaractDoc();

         CaractDoc *tmpDoc;
         total_finestres=Finestres->count();

         tmpDoc = pDoc->first();
         while (l < total_finestres && k<2){    //busquem les 2 primeres caselles seleccionades
            if (Finestres->isSelected(l)){
               imat[k]=&(tmpDoc->imatge);
               imatPos[k]=l;      
               k++;
            }
            l++;
            tmpDoc = pDoc->next();
         }

         if (!imat[0]->imatge.mesD2colors() && !imat[1]->imatge.mesD2colors()){         
            if (OpcioEquidistants->isChecked()){  //SI han de ser equidistants
               if (OpcioFFT->isChecked()){         //Fem FFT
                  if (OpcioFourier1->isChecked()){      //Retorna complexes
                     
                     bool ha_nat;
                     int d;

                     s=EntradaPas->text();
                     d=s.toInt(&ha_nat);

                     if (!ha_nat)
                        EntradaPas->validateAndSet ( "ERROR", 0, 0, 5);
                     else if (OpcioFFT->isChecked()){
                        if (d & (d-1)) //truco per mirar si es potencia d 2
                           EntradaPas->validateAndSet ( "Potencia de 2 !", 0, 0, 15);
                     }

                     if ((!(d & (d-1)) || !OpcioFFT->isChecked()) && ha_nat){
                        tmp="_________________________________<BR>";
                        tmp+="FOURIER  :  COORDENADA COMPLEXE<BR>";
                        tmp+="\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257<BR>";
                        

                           if (imat[0]->contornejada==false){    //la finestra activa ja te la llista montada pero les altres no!!
                              rmImage tmp;
                              doc2->imatge.imatge=pDoc->at(imatPos[0])->imatge.imatge;
                              doc2->imatge.zm=imat[0]->zm;

                              //nou document am nou titol
                              fileName=pDoc->at(imatPos[0])->title();
                              QString s = fileName.section( '/', -1 );    //agafa unicament el nom
                              fileName = ("(%) ");
                              int n;
                              if (imat[0]->dw->augments >= 1)
                                 n=imat[0]->dw->augments*100;
                              else
                                 n=imat[0]->dw->augments/100;

                              while(n>0){
                                 fileName.insert(1,(n%10)+48);
                                 n=n/10;
                              }
                              doc2->setPathName ("Contorn_" + s);
                              doc2->setTitle (fileName + "Contorn_" + s);

                              doc2->imatge.Contorn(*imat[0]);
                              doc2->imatge.RecorreAntihorari();

                              //aplikem el zoom pq quedi igual
                              if (doc2->imatge.zm.augments<=1)
                                 doc2->imatge.zm.augmentarIntel(doc2->imatge.imatge);
                              else
                                 doc2->imatge.zm.disminuirIntel (doc2->imatge.imatge);

                              doc2->imatge.dw->augments=doc2->imatge.zm.augments;
                              doc2->imatge.dw->enfocat=true;
                              doc2->imatge.dw->xMin=doc2->imatge.zm.xMin;
                              doc2->imatge.dw->yMin=doc2->imatge.zm.yMin;

                              doc2->imatge.zm.resImg(&tmp);
                              doc2->imatge.ompleQImage(tmp);

                              pDoc->append(doc2);
                              doc2->newDocument();
                              docs[0]=doc2;
                              }
                           if (imat[1]->contornejada==false){

                              rmImage tmp;
                              doc3->imatge.imatge=pDoc->at(imatPos[1])->imatge.imatge;
                              doc3->imatge.zm=imat[1]->zm;

                              //nou document am nou titol
                              fileName=pDoc->at(imatPos[1])->title();
                              QString s = fileName.section( '/', -1 );    //agafa unicament el nom
                              fileName = ("(%) ");
                              int n;
                              if (imat[1]->dw->augments >= 1)
                                 n=imat[1]->dw->augments*100;
                              else
                                 n=imat[1]->dw->augments/100;

                              while(n>0){
                                 fileName.insert(1,(n%10)+48);
                                 n=n/10;
                              }
                              doc3->setPathName ("Contorn_" + s);
                              doc3->setTitle (fileName + "Contorn_" + s);

                              doc3->imatge.Contorn(*imat[1]);
                              doc3->imatge.RecorreAntihorari();

                              //aplikem el zoom pq quedi igual
                              if (doc3->imatge.zm.augments<=1)
                                 doc3->imatge.zm.augmentarIntel(doc3->imatge.imatge);
                              else
                                 doc3->imatge.zm.disminuirIntel (doc3->imatge.imatge);

                              doc3->imatge.dw->augments=doc3->imatge.zm.augments;
                              doc3->imatge.dw->enfocat=true;
                              doc3->imatge.dw->xMin=doc3->imatge.zm.xMin;
                              doc3->imatge.dw->yMin=doc3->imatge.zm.yMin;

                              doc3->imatge.zm.resImg(&tmp);
                              doc3->imatge.ompleQImage(tmp);

                              pDoc->append(doc3);
                              doc3->newDocument();
                              docs[1]=doc3;
                              }

                           Fourier forma(doc2->imatge, d);
                           Fourier forma1 (doc3->imatge,d);


                           forma.Fourier1Equi(doc2->imatge, OpcioFFT->isChecked());
                           forma1.Fourier1Equi(doc3->imatge, OpcioFFT->isChecked());


                           tmp+=forma.MostraComparacio(forma1);

                           tmp+=AltresCaracteristiques(*img);

                           doc2->imatge.dw->Text.setText(tmp);
                           doc3->imatge.dw->Text.setText(tmp);

                           close();
                           }
                     }
                     else if (OpcioFourier2->isChecked()){
                        QString s;
                        bool ha_nat;
                        int d;

                        s=EntradaPas->text();
                        d=s.toInt(&ha_nat);

                        if (!ha_nat)
                           EntradaPas->validateAndSet ( "ERROR", 0, 0, 5);
                        else if (OpcioFFT->isChecked()){
                           if (d & (d-1))
                              EntradaPas->validateAndSet ( "Potencia de 2 !", 0, 0, 15);
                        }

                        if ((!(d & (d-1)) || !OpcioFFT->isChecked()) && ha_nat){
                           tmp="______________________________<BR>";
                           tmp+="FOURIER  :  DISTANCIA AL CENTRE<BR>";
                           tmp+="\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257\257<BR>";
                                                               

                           if (imat[0]->contornejada==false){    //la finestra activa ja te la llista montada pero les altres no!!
                              rmImage tmp;
                              doc2->imatge.imatge=pDoc->at(imatPos[0])->imatge.imatge;
                              doc2->imatge.zm=imat[0]->zm;

                              //nou document am nou titol
                              fileName=pDoc->at(imatPos[0])->title();
                              QString s = fileName.section( '/', -1 );    //agafa unicament el nom
                              fileName = ("(%) ");
                              int n;
                              if (imat[0]->dw->augments >= 1)
                                 n=imat[0]->dw->augments*100;
                              else
                                 n=imat[0]->dw->augments/100;

                              while(n>0){
                                 fileName.insert(1,(n%10)+48);
                                 n=n/10;
                              }
                              doc2->setPathName ("Contorn_" + s);
                              doc2->setTitle (fileName + "Contorn_" + s);

                              doc2->imatge.Contorn(*imat[0]);
                              doc2->imatge.RecorreAntihorari();

                              //aplikem el zoom pq quedi igual
                              if (doc2->imatge.zm.augments<=1)
                                 doc2->imatge.zm.augmentarIntel(doc2->imatge.imatge);
                              else
                                 doc2->imatge.zm.disminuirIntel (doc2->imatge.imatge);

                              doc2->imatge.dw->augments=doc2->imatge.zm.augments;
                              doc2->imatge.dw->enfocat=true;
                              doc2->imatge.dw->xMin=doc2->imatge.zm.xMin;
                              doc2->imatge.dw->yMin=doc2->imatge.zm.yMin;

                              doc2->imatge.zm.resImg(&tmp);
                              doc2->imatge.ompleQImage(tmp);

                              pDoc->append(doc2);
                              doc2->newDocument();
                              docs[0]=doc2;
                           }
                           if (imat[1]->contornejada==false){
                              rmImage tmp;
                              doc3->imatge.imatge=pDoc->at(imatPos[1])->imatge.imatge;
                              doc3->imatge.zm=imat[1]->zm;

                              //nou document am nou titol
                              fileName=pDoc->at(imatPos[1])->title();
                              QString s = fileName.section( '/', -1 );    //agafa unicament el nom
                              fileName = ("(%) ");
                              int n;
                              if (imat[1]->dw->augments >= 1)
                                 n=imat[1]->dw->augments*100;
                              else
                                 n=imat[1]->dw->augments/100;

                              while(n>0){
                                 fileName.insert(1,(n%10)+48);
                                 n=n/10;
                              }
                              doc3->setPathName ("Contorn_" + s);
                              doc3->setTitle (fileName + "Contorn_" + s);

                              doc3->imatge.Contorn(*imat[1]);
                              doc3->imatge.RecorreAntihorari();

                              //aplikem el zoom pq quedi igual
                              if (doc3->imatge.zm.augments<=1)
                                 doc3->imatge.zm.augmentarIntel(doc3->imatge.imatge);
                              else
                                 doc3->imatge.zm.disminuirIntel (doc3->imatge.imatge);

                              doc3->imatge.dw->augments=doc3->imatge.zm.augments;
                              doc3->imatge.dw->enfocat=true;
                              doc3->imatge.dw->xMin=doc3->imatge.zm.xMin;
                              doc3->imatge.dw->yMin=doc3->imatge.zm.yMin;

                              doc3->imatge.zm.resImg(&tmp);
                              doc3->imatge.ompleQImage(tmp);

                              pDoc->append(doc3);
                              doc3->newDocument();
                              docs[1]=doc3;
                           }

                           Fourier forma(doc2->imatge, d);
                           Fourier forma1 (doc3->imatge,d);


                           forma.Fourier2Equi(doc2->imatge, OpcioFFT->isChecked());
                           forma1.Fourier2Equi(doc3->imatge, OpcioFFT->isChecked());


                           tmp+=forma.MostraComparacio(forma1);

                           tmp+=AltresCaracteristiques(*img);

                           doc2->imatge.dw->Text.setText(tmp);
                           doc3->imatge.dw->Text.setText(tmp);

                           close();
                        }
                     }
                  }
               }
         }
         else{       //si hi ha alguna imatge k no esta binaritzada de les k es vol comparar passa per aki
            delete doc2;
            delete doc3;
            QMessageBox::critical (this, tr("I/O Error !"), tr("Una de les imatges seleccionades no esta binaritzada"));
            close();
            CANCELAR=true;
         }
      }
   }   
}

bool DialegFourier::Inicialitza(){
   int espai=25, pos=40, i=1;
   QString s;
   tipus=-1;

  GrupMetode = new QButtonGroup("FOURIER", this);
  GrupMetode->setGeometry (QRect(28,25,130,270));

     OpcioFourier1 = new QRadioButton ("Coordenada\nComplexe", GrupMetode);
     OpcioFourier1->setGeometry (QRect(20,30,95,/*15*/40));
     OpcioFourier1->setChecked(TRUE);

     OpcioFourier2 = new QRadioButton ("Distancia\nal Centre", GrupMetode);
     OpcioFourier2->setGeometry (QRect(20,/*55*/80,90,/*15*/40));

     OpcioFFT = new QCheckBox ("FFT", GrupMetode);
     OpcioFFT->setGeometry (QRect(20,160,50,15));
     OpcioFFT->setChecked(TRUE);
     connect (OpcioFFT, SIGNAL (stateChanged(int)), this, SLOT(slotUpdateFFT(int)));
     

     OpcioEquidistants = new QCheckBox ("Equidistants", GrupMetode);
     OpcioEquidistants->setGeometry (QRect(20,185,90,15));
     OpcioEquidistants->setChecked(TRUE);
     connect(OpcioEquidistants, SIGNAL(stateChanged(int)), this, SLOT(slotUpdateEntrada(int)));


     while (i < img->contorn->perimetre)    //Total de mostres a agafar
         i*=2;

     Etiqueta = new QLabel ("Total Mostres:", GrupMetode);
     Etiqueta->setGeometry (QRect(20, 215, 90, 20));
     
     EntradaPas = new  QLineEdit (s.setNum(i), GrupMetode);
     EntradaPas->setGeometry (QRect(20, 235, 92, 20));

     
   GrupCaract = new QButtonGroup("Altres dades", this);
   GrupCaract->setGeometry (QRect(186,25,130,270));  
           OpcioArea = new QCheckBox ("Area", GrupCaract);
           OpcioArea->setGeometry (QRect(10,pos,90,15));

           OpcioPerimetre = new QCheckBox ("Perimetre", GrupCaract);
           OpcioPerimetre->setGeometry (QRect(10,pos+=espai,90,15));
           
           OpcioMinRectangle = new QCheckBox ("Rectangle minim", GrupCaract);
           OpcioMinRectangle->setGeometry (QRect(10,pos+=espai,115,15));

           OpcioCompactnes = new QCheckBox ("Compactesa", GrupCaract);
           OpcioCompactnes->setGeometry (QRect(10,pos+=espai,110,15));

           OpcioLength = new QCheckBox ("Alcada", GrupCaract);
           OpcioLength->setGeometry (QRect(10,pos+=espai,90,15));

           OpcioBreadth = new QCheckBox ("Amplada", GrupCaract);
           OpcioBreadth->setGeometry (QRect(10,pos+=espai,90,15));

           OpcioElongation = new QCheckBox ("Elongacio", GrupCaract);
           OpcioElongation->setGeometry (QRect(10,pos+=espai,90,15));

           OpcioCentreGravetat = new QCheckBox ("Centre gravetat", GrupCaract);
           OpcioCentreGravetat->setGeometry (QRect(10,pos+=espai,110,15));

      Finestres = new QListBox (this, "Finestretes");
      Finestres->setGeometry (QRect(344,31,130,240));
      Finestres->setSelectionMode (QListBox::Multi);
      Finestres->setEnabled(FALSE);
//      connect (Finestres, SIGNAL (highlighted (int)),this, SLOT (slotSeleccionenDos(int)));
      connect (Finestres, SIGNAL (mouseButtonClicked (int, QListBoxItem *, const QPoint &)),this, SLOT (slotSeleccionenDos(int, QListBoxItem *, const QPoint &))); 

      OpcioComparar = new QCheckBox ("Comparar 2 imatges", this);
      OpcioComparar->setGeometry (QRect(344,276,160,25));
      connect(OpcioComparar, SIGNAL(stateChanged(int)), this, SLOT(slotUpdateComparar(int)));

      CaractDoc *tmp;
      QString fileName;
      for ( tmp = pDoc->first(); tmp; tmp = pDoc->next() ){
          fileName=QString(tmp->title());
          fileName = fileName.section( '/', -1 );    //agafa unicament el nom
          Finestres->insertItem(fileName);
      }


   //botons acceptar i cancelar
   botoOk = new QPushButton(this,"ok");
   botoOk->setGeometry( QRect( 360, 330, 93, 26 ) );
   botoOk->setText( "Ok" );
   connect(botoOk, SIGNAL(clicked()), this, SLOT(slotBotoOK()));

   botoCancel = new QPushButton(this,"cancelar");
   botoCancel->setGeometry( QRect( 470, 330, 93, 26 ) );
   botoCancel->setText( "Cancelar");
   connect(botoCancel, SIGNAL(clicked()), this, SLOT(slotBotoCANCEL()));


   GrupBD = new QButtonGroup(this);
   GrupBD->setGeometry (QRect(28, 310,274,71));

   EtiquetaNom = new QLabel ("Tipus:", GrupBD);
   EtiquetaNom->setGeometry (QRect(15, 35, 70, 20));

   nom = new QLineEdit (inicial, GrupBD);
   nom->setGeometry (QRect(60, 35, 100, 20));


   OpcioAfegeix = new QCheckBox ("Afegeix a la BD",GrupBD,"Afegeix a la BD");
   OpcioAfegeix->setGeometry( QRect( 5, 5, 115, 15 ) );
   connect(OpcioAfegeix, SIGNAL(stateChanged(int)), this, SLOT(slotUpdateAfegeix(int)));

   GrupReconeixement = new QButtonGroup("Reconeixement", this);
   GrupReconeixement->setGeometry (QRect(490,25,130,270));
   connect(GrupReconeixement, SIGNAL(released(int)), this, SLOT(slotRec(int)));

      OpcioRec = new QCheckBox ("Reconeixement", GrupReconeixement);
      OpcioRec->setGeometry (QRect(10,30,110,15));


      OpcioCBIR = new QCheckBox ("CBIR", GrupReconeixement);
      OpcioCBIR->setGeometry (QRect(10,130,90,15));

      MesSemblants = new QLineEdit (GrupReconeixement);
      MesSemblants->setGeometry (QRect(70, 122, 40, 20));
      MesSemblants->setDisabled (TRUE);

      OpcioRecFF = new QCheckBox ("Descriptor\nUnic", GrupReconeixement);
      OpcioRecFF->setGeometry (QRect(25,230,90,30));
      OpcioRecFF->setEnabled(FALSE);



   GrupTipus1 = new QButtonGroup (GrupReconeixement);
   GrupTipus1->setGeometry (QRect (25,50, 95, 66));
   GrupTipus1->setLineWidth(0);
   GrupTipus1->setDisabled(true);
      OpcioMamo1 = new QRadioButton ("Mamo", GrupTipus1);
      OpcioMamo1->setGeometry (QRect (0, 5, 90, 15));
      OpcioSintet1 = new QRadioButton ("Sintetica", GrupTipus1);
      OpcioSintet1->setGeometry (QRect (0, 26, 90, 15));
      OpcioFurqui1 = new QRadioButton ("Altres", GrupTipus1 );
      OpcioFurqui1->setGeometry (QRect (0, 47, 90, 15));


   GrupTipus2 = new QButtonGroup (GrupReconeixement);
   GrupTipus2->setGeometry (QRect (25,150, 95, 66));
   GrupTipus2->setLineWidth(0);
   GrupTipus2->setDisabled(true);
      OpcioMamo2 = new QRadioButton ("Mamo", GrupTipus2);
      OpcioMamo2->setGeometry (QRect (0, 5, 90, 15));
      OpcioSintet2 = new QRadioButton ("Sintetica", GrupTipus2);
      OpcioSintet2->setGeometry (QRect (0, 26, 90, 15));
      OpcioFurqui2 = new QRadioButton ("Altres", GrupTipus2 );
      OpcioFurqui2->setGeometry (QRect (0, 47, 90, 15));

   GrupTipus = new QButtonGroup (GrupBD);
   GrupTipus->setGeometry (QRect (175,2, 95, 66));
   GrupTipus->setLineWidth(0);
   GrupTipus->setDisabled(TRUE);
      OpcioMamo = new QRadioButton ("Mamo", GrupTipus);
      OpcioMamo->setGeometry (QRect (0, 5, 90, 15));
      OpcioSintet = new QRadioButton ("Sintetica", GrupTipus);
      OpcioSintet->setGeometry (QRect (0, 26, 90, 15));
      OpcioFurqui = new QRadioButton ("Altres", GrupTipus);
      OpcioFurqui->setGeometry (QRect (0, 47, 90, 15));
   
/// LINIA K SOBRA !!!!
             /*
OpcioAfegeix->setChecked (true);
  slotUpdateAfegeix(2);
  EntradaPas->setText (s.setNum(512));
    OpcioFourier2->setChecked(true);
               */

   return (true);
}


QString DialegFourier::AltresCaracteristiques (Imatge &im){
   f = new forma;
   QString vector,a;

   f->extreureMinBox(im.imatge);    //Sha de fer per calcular qualsevol cosa

    if (OpcioArea->isChecked() || OpcioPerimetre->isChecked() || OpcioElongation->isChecked() || OpcioMinRectangle->isChecked()
   || OpcioCompactnes->isChecked() || OpcioLength->isChecked() || OpcioBreadth->isChecked() || OpcioCentreGravetat->isChecked())
      vector+="<BR>ALTRES CARACTERISTIQUES<BR>";

   if (OpcioArea->isChecked()){
      f->varea=area;
      vector+="Area = ";
      vector+= a.setNum(area) + "<BR>";      
      }      
   if (OpcioPerimetre->isChecked()){
/*      Imatge image;
      
      image=*img;   //faig una copia de la rmImage


      vector+="Perimetre = ";
      image.Contorn(im);
      f->vperimetre=image.CalculaPerimetre();
*/
      vector+="Perimetre = ";
      f->vperimetre=im.contorn->perimetre;
      vector+= a.setNum(f->vperimetre) + "<BR>";
      }
   if (OpcioElongation->isChecked()){
      f->elongation(0, im.imatge);
      vector+= "Elongacio = ";
      vector+= a.setNum(f->velongacio) + "<BR>";
      }
   if (OpcioMinRectangle->isChecked()){
      vector+= "Coordenades del Rectangle Minim = (";
      vector+= a.setNum(f->xMin);
      vector+= ", " + a.setNum(f->yMin);
      vector+= ")   (" + a.setNum(f->xMax);
      vector+= ", " + a.setNum (f->yMax) + ")<BR>";
      }
   if (OpcioCompactnes->isChecked()){  //ens calen el perimetre i l'area per calcular la compaccitat
      if (!OpcioPerimetre->isChecked()){
         Imatge image;

         image=*img;   //faig una copia de la rmImage

         image.Contorn(im);
         f->vperimetre=image.CalculaPerimetre();
      }

      if (!OpcioArea->isChecked())
         f->area(im.imatge);

      f->compactness(im.imatge);
      vector+= "Compactness = ";
      vector+= a.setNum(f->vcompactness) + "<BR>";
      }
   if (OpcioLength->isChecked()){
      f->length();
      vector+= "Length = ";
      vector+= a.setNum(f->vlength) + "<BR>";
      }
   if (OpcioBreadth->isChecked()){
      f->breath();
      vector+= "Breadth = ";
      vector+= a.setNum(f->vbreadth) + "<BR>";
      }
   if (OpcioCentreGravetat->isChecked()){
      f->centroid();
      vector+= "Centre de gravetat = (";
      vector+= a.setNum(f->vcentroidX);
      vector+= ", " + a.setNum(f->vcentroidY);
      vector+= ")<BR>";
      }



   return (vector);
}

void DialegFourier::slotValorEntrat (){
   QString s;
   int d;
   bool ha_nat;
   
   s=EntradaPas->text();
   d=s.toInt(&ha_nat);

         if (!ha_nat)
            EntradaPas->validateAndSet ( "ERROR", 0, 0, 5);
         else if (OpcioFFT->isChecked()){
            while (d%2==0){
               d/=2;
               }

            if (d%2==1)
               EntradaPas->validateAndSet ( "Potencia de 2 !", 0, 0, 15);
         }
                            
   if (!ha_nat)
      EntradaPas->validateAndSet ( "ERROR", 0, 0, 0);

   else{
      if (OpcioFFT->isChecked()){
         while (d%2==0)
            d/=2;


         
         while (d>1)
            d/=2;
         if (d==1)
            EntradaPas->validateAndSet ( "E - 2^", 0, 0, 0);
      }
   }
}


void DialegFourier::slotUpdateEntrada(int a){
   if (!OpcioFFT->isChecked()){  //si lopcio FFT esta activa han d ser equidistants forcosament
      if (a!=2){
         EntradaPas->setDisabled(TRUE);
         Etiqueta->setDisabled(TRUE);
      }
      else{
         EntradaPas->setDisabled(FALSE);
         Etiqueta->setDisabled (FALSE);
      }
   }
   else{
         OpcioEquidistants->setChecked(TRUE);
   }
   
}


void DialegFourier::slotUpdateFFT(int a){
   if (a==2){
      EntradaPas->setDisabled(FALSE);
      Etiqueta->setDisabled (FALSE);
      OpcioEquidistants->setChecked(TRUE);
   }
}


   
void DialegFourier::slotUpdateAfegeix(int a){
   if (a==2){   //BOTO PITXAT
      
      GrupReconeixement->setDisabled(TRUE);
      GrupTipus->setDisabled(FALSE);
      OpcioSintet->setChecked(TRUE);

      tipus=1;
      OpcioFFT->setChecked(TRUE);
      OpcioFFT->setDisabled(TRUE);

      OpcioComparar->setChecked(FALSE);
      OpcioComparar->setDisabled(TRUE);
      
      OpcioEquidistants->setChecked(TRUE);
      

      OpcioCentreGravetat->setChecked(TRUE);
      OpcioCentreGravetat->setDisabled(TRUE);
      
      OpcioArea->setChecked(TRUE);
      OpcioArea->setDisabled(TRUE);

      OpcioBreadth->setChecked(TRUE);
      OpcioBreadth->setDisabled(TRUE);
      
      OpcioCompactnes->setChecked(TRUE);
      OpcioCompactnes->setDisabled(TRUE);
      
      OpcioElongation->setChecked(TRUE);
      OpcioElongation->setDisabled(TRUE);
      
      OpcioMinRectangle->setChecked(TRUE);
      OpcioMinRectangle->setDisabled(TRUE);
      
      OpcioPerimetre->setChecked(TRUE);
      OpcioPerimetre->setDisabled(TRUE);
      
      OpcioLength->setChecked(TRUE);
      OpcioLength->setDisabled(TRUE);
   }
   else if (a==0){   //boto no pitxat
      GrupReconeixement->setDisabled(FALSE);
      OpcioSintet->setChecked(FALSE);

      tipus=-1;
      OpcioComparar->setDisabled(FALSE);
      
      OpcioFFT->setDisabled(FALSE);
      OpcioEquidistants->setDisabled(FALSE);
      OpcioCentreGravetat->setDisabled(FALSE);
      OpcioArea->setDisabled(FALSE);
      OpcioBreadth->setDisabled(FALSE);
      OpcioCompactnes->setDisabled(FALSE);
      OpcioElongation->setDisabled(FALSE);
      OpcioMinRectangle->setDisabled(FALSE);
      OpcioPerimetre->setDisabled(FALSE);
      OpcioLength->setDisabled(FALSE);
   }
}

//FA REFERENCIA AL DE CONSULTA
void DialegFourier::slotUpdateComparar(int a){
   if (a==2){   //boto pitxat
      GrupReconeixement->setDisabled(TRUE);
      Finestres->setDisabled(FALSE);
      OpcioAfegeix->setChecked(FALSE);
      OpcioAfegeix->setDisabled(TRUE);
      EtiquetaNom->setDisabled(TRUE);
      nom->setDisabled(TRUE);
      }
   else if (a==0){   //boto sense pitxar
      GrupReconeixement->setDisabled(FALSE);
      Finestres->setDisabled(TRUE);
      OpcioAfegeix->setDisabled(FALSE);
      EtiquetaNom->setDisabled(FALSE);
      nom->setDisabled(FALSE);
      Finestres->clearSelection();
      }
}


//Gestio de les opcions de la base de dades
void DialegFourier::slotRec(int a){
   tipus=-1;

   if (a==0 && OpcioRec->isChecked()){   //han pitxat Rec
      OpcioComparar->setDisabled (TRUE);
      MesSemblants->setDisabled (TRUE);
      OpcioMamo2->setChecked(false);     //des-xequegem CBIR
      OpcioSintet2->setChecked(false);
      OpcioFurqui2->setChecked(false);
      GrupTipus1->setDisabled(false);
      OpcioCBIR->setChecked(FALSE);
      GrupBD->setDisabled (TRUE);
      GrupTipus2->setDisabled(TRUE);
      GrupTipus1->setDisabled(FALSE);
      GrupCaract->setDisabled(TRUE);
      OpcioSintet1->setChecked (true);
      OpcioFFT->setDisabled (TRUE);
      OpcioFFT->setChecked (TRUE);
      OpcioEquidistants->setDisabled (TRUE);
      OpcioEquidistants->setChecked (TRUE);
      OpcioRecFF->setEnabled(TRUE);   
   }
   else if (a==1 && OpcioCBIR->isChecked()){
      OpcioComparar->setDisabled (TRUE);
      MesSemblants->setDisabled (FALSE);      
      OpcioMamo1->setChecked(false);
      OpcioSintet1->setChecked(false);
      OpcioFurqui1->setChecked(false);
      GrupTipus2->setDisabled(false);
      OpcioRec->setChecked(FALSE);
      GrupBD->setDisabled(TRUE);
      GrupTipus1->setDisabled(TRUE);
      GrupTipus2->setDisabled(FALSE);
      GrupCaract->setDisabled (FALSE);
      OpcioSintet2->setChecked (true);
      OpcioRecFF->setEnabled(TRUE);
      OpcioFFT->setDisabled (TRUE);
      OpcioFFT->setChecked (TRUE);
      OpcioEquidistants->setDisabled (TRUE);
      OpcioEquidistants->setChecked (TRUE);
   }
   else if (!OpcioRec->isChecked() && !OpcioCBIR->isChecked()){   //no volem res
      OpcioComparar->setDisabled (FALSE);
      MesSemblants->setDisabled (TRUE);   
      OpcioMamo1->setChecked(false);   //des-seleccionem qualsevol opcio
      OpcioSintet1->setChecked(false);
      OpcioFurqui1->setChecked(false);
      OpcioMamo2->setChecked(false);
      OpcioSintet2->setChecked(false);
      OpcioFurqui2->setChecked(false);
      GrupTipus1->setDisabled(TRUE);
      GrupTipus2->setDisabled(TRUE);
      GrupBD->setDisabled(FALSE);
      GrupCaract->setDisabled (FALSE);
      OpcioRecFF->setEnabled(FALSE);
      OpcioFFT->setDisabled (FALSE);
      OpcioEquidistants->setDisabled (FALSE);
   }
}

//void DialegFourier::slotSeleccionenDos(int a){
void DialegFourier::slotSeleccionenDos(int button, QListBoxItem * item, const QPoint & pos){
                      
   int conta, selec=0, i=0, max=0;
   QString s;

   conta=Finestres->count();

   //conta els seleccionats
   while (i<conta){
      if (Finestres->isSelected(i)){
         selec++;
      }
      i++;
   }

//   cout << Finestres->index (item) << "   " << selec << endl;
   if (selec>2)   //desseleciona l'ultim i selecciona el nou
      Finestres->setSelected(item,false);
   else{
      if (selec>0){  //hi ha d'haver alguna seleccio feta <3
         i=0;
         max=1;
         CaractDoc *tmpDoc = pDoc->first();
         while (i < conta){  //busquem el mostreig adequat
            if (Finestres->isSelected(i)){
               Imatge imtmp;
               imtmp.imatge=tmpDoc->imatge.imatge;
               if (!tmpDoc->imatge.contornejada){    //la finestra pot ser k no tingui la llista montada                  
                  imtmp.Contorn(tmpDoc->imatge);
                  imtmp.RecorreAntihorari();
                  imtmp.contorn->perimetre;    //nomes m'interessa el perimetre per actualitzar el mostreig
               }
               if (max < imtmp.contorn->mostresOK)
                  max=imtmp.contorn->mostresOK;
            }
            i++;
            tmpDoc = pDoc->next();
         }
         EntradaPas->setText (s.setNum(max));
      }
   }                
}
