/***************************************************************************
                          chang.cpp  -  description
                             -------------------
    begin                : mié nov 19 2003
    copyright            : (C) 2003 by projecte
    email                : projecte@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "chang.h"


Chang::Chang(){
   float *c = new float;
   *c=-1.0;
   llistaModuls = new QPtrList<float>;
   llistaModuls->prepend(c);
}
Chang::~Chang(){
   //esborrem la llista amb els moduls
   while (llistaModuls->first()!=NULL)
      llistaModuls->removeFirst();
}

void Chang::CalcularDescriptors(Imatge &imatge){
   CMasses(imatge);
   ModulOrdenat(imatge);
}

//Calcula el centre de masses de la figura
void Chang::CMasses(Imatge &imatge){

  int  Ti=0, Tj=0, Tpunts=0;

  for(int i=0;i<imatge.imatge.dimX;i++){
    for(int j=0;j<imatge.imatge.dimY;j++){
       if(imatge.imatge.data(i,j)==0){
         Ti+=i;
         Tj+=j;
         Tpunts++;
       }
    }
  }
   imatge.dw->centreX=(float)Ti/Tpunts;
   imatge.dw->centreY=(float)Tj/Tpunts; 
}


int comparar (const void *a, const void *b){
   if (*(float*)a > *(float*)b)
      return (1);
   else if (*(float*)a < *(float*)b)
      return (-1);
   else
      return(0);
}
  
//Fa el modul ordena i a mes aplica escalat
void Chang::ModulOrdenat(Imatge &imatge){

   float *modul, *vector, *p;
   float max;
   int tamany, i;
   
   if (!imatge.dw->llista->isEmpty()){

      coordenades obj;

      obj=imatge.dw->llista->first();
       while (obj.X!=-1){
          modul = new float;
          *modul=(float)sqrt (pow(obj.X-imatge.dw->centreX,2)+pow(obj.Y-imatge.dw->centreY,2));
          llistaModuls->prepend(modul);
          obj=imatge.dw->llista->next();          
       }
       

       llistaModuls->removeLast();  //Esborrem el centinella -1
       
       //copiem la llista per ordenar-la      
       vector = new float[llistaModuls->count()];
       tamany=llistaModuls->count();
       p=llistaModuls->first();
       for (i=0;i<tamany;i++){ //copiem la llista a un vector
         vector[i]=*p;
         delete (p);
         p=llistaModuls->next();
         }
         
       delete (llistaModuls);
       
       //ordenem el vector
       qsort(vector, tamany, sizeof(float), comparar);
                           

       llistaModuls = new QPtrList<float>;
       for (i=0;i<tamany;i++){
          p=new float;
          *p=vector[i];
          llistaModuls->prepend(p);
       }

          
       float *centinella = new float;
       *centinella=-1.0;
       llistaModuls->append(centinella);     //Posem el centinella a l'ultima posicio

              
       max=*(llistaModuls->first());    //Conte el valor mes gran pel que escalarem       
       if (!llistaModuls->isEmpty()){
         modul=llistaModuls->first();                  
         
         while (*modul!=-1.0){
            *modul=*modul/max;                    
            modul=llistaModuls->next();
         }
      }
   }
}
                                  
//Prepara la sortida de dades per pantalla
QString Chang::MostraPunts(Imatge &imatge){
   QString vector, a;
   coordenades obj;
   float modul;
   
   vector+= "Punts escollits: ";

   obj=imatge.dw->llista->first();
   while (obj.X != -1){                          //Escriu coordenades
      vector+= "(" + a.setNum (obj.X) + ", ";
      vector+=a.setNum (obj.Y) + ")  ";
      obj=imatge.dw->llista->next();
      }
   
   vector+= "<BR>";
   vector+="          TOTAL PUNTS=" + a.setNum((llistaModuls->count())-1);
   vector+= "<BR>";
   vector += "Moduls ordenats: ";

   modul=*(llistaModuls->first());
   while (modul!=-1.0){
      vector+= a.setNum (modul) + "   ";
      modul=*(llistaModuls->next());
   }

   vector += "<BR>";
   vector +="Centre de masses: (" + a.setNum(imatge.dw->centreX);
   vector += ", " + a.setNum(imatge.dw->centreY) + ")";

   return (vector);
}
                         
  

    