/***************************************************************************
                          fourier.h  -  description
                             -------------------
    begin                : mié dic 10 2003
    copyright            : (C) 2003 by projecte
    email                : projecte@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FOURIER_H
#define FOURIER_H

#include "../../imatge.h"
//#include <qmsgbox.h>
/**
  *@author projecte
  */


typedef struct{
                           complexe *preFD;      //valors amb els quals trobarem els descriptors de fourier
                           double *FD;    //descriptors d fourier
                           int plensFD;
                           int plenspreFD;
                           int metode;
                  }t_descriptorsZ;

class Fourier {
public: 
	Fourier(Imatge&, int mostres);
	~Fourier();
   void CMasses(Imatge&);
   void Fourier1 (Imatge &);                 //complex coordinates            1
   void Fourier2 (Imatge &);                 //centroid distance                 2
   void Fourier1Equi (Imatge &imatge, bool fft);        //complex coordinates equidistants       3
   void Fourier2Equi (Imatge &imatge, bool fft);     //centroid distance equidistans                4
   QString MostraPunts(Imatge &);
   void DescriptorsFourier ();       //Fins que no fem l'escalat no tindrem els FD
   void DescriptorUnic ();
   void FFT (int, int);
   void DFT();



   QString MostraComparacio(Fourier&);
   complexe *punter_a_Z;       //Aixo te valor si s'executem fourier1    PUNTER A COMPLEXE
   t_descriptorsZ descriptZ;
   complexe *v_mostres;       //mostres equidistants k agafem   
   double resultat;         //descriptor unic
   double *nfd;   
   int mostres;   //total de DF que tenim si fem equidistants
   ContornL *totContorn;
   
private:
   void escala ();   //Obte els FD a partir dels  preFD
   void AntiTransformada ();
   void EquidistaPixels (Imatge& im, double pas);   //Obtenim mostres del contorn equidistants
   complexe passa_a_polar (double x, double y);
   complexe passa_a_complexe (double modul, double fase);


};

#endif
