/***************************************************************************
                          zoom.cpp  -  description
                             -------------------
    begin                : jue nov 7 2002
    copyright            : (C) 2002 by Joan
    email                : Joan@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "zoom.h"

Zoom::Zoom(){
  cbase=0;
  cred=0;
  cgreen=0;
  cblue=0;
}

Zoom::~Zoom(){
}

// augmenta el zoom i omple la qimage
void Zoom::augmentar(rmImage &base,rmImage &mbase,int iw,int ih){
  int i,j;
  short valor,*lut;
  int profunditat=1;
    // calcula la profunditat
    i=0;
    while(i<base.bits){
      profunditat=profunditat*2;
      i++;
    }
      // crea la lut
    lut = new short[profunditat];
    if(lut==0){
      cout << "Error al crear la lut!" << endl;
      return;
    }
    profunditat--;
    for(i=0;i<profunditat+1;i++){
      lut[i]=(byte)((double)i*(255.0/profunditat));
      if(lut[i]>255) lut[i]=255;
    }

      // inicialitza la qimage
      zimg.create(w,h,32);
      // aplica l'augment
      switch(cbase){
        case 0:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              valor=lut[base.data(i/iw,j/ih)];
              if(mbase.data(i/iw,j/ih)==0) zimg.setPixel(i,j,qRgb(valor,valor,valor));
              else zimg.setPixel(i,j,qRgb(valor,cgreen,cblue));
            }
          }
         break;
        case 1:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              valor=lut[base.data(i/iw,j/ih)];
              if(mbase.data(i/iw,j/ih)==0) zimg.setPixel(i,j,qRgb(valor,valor,valor));
              else zimg.setPixel(i,j,qRgb(cred,valor,cblue));
            }
          }
         break;
        case 2:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              valor=lut[base.data(i/iw,j/ih)];
              if(mbase.data(i/iw,j/ih)==0) zimg.setPixel(i,j,qRgb(valor,valor,valor));
              else zimg.setPixel(i,j,qRgb(cred,cgreen,valor));
            }
          }
         break;
      }
      delete lut;
      // marca el contorn
      switch(cbase){
        case 0:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              if(i>0&&i<w-1&&j>0&&j<h-1){
                if(qRed(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  if(qRed(zimg.pixel(i-1,j))==qGreen(zimg.pixel(i-1,j))||
                     qRed(zimg.pixel(i+1,j))==qGreen(zimg.pixel(i+1,j))||
                     qRed(zimg.pixel(i,j-1))==qGreen(zimg.pixel(i,j-1))||
                     qRed(zimg.pixel(i,j+1))==qGreen(zimg.pixel(i,j+1))){
                      zimg.setPixel(i,j,qRgb(255,cgreen,cblue));
                  }
                }
              }
              else{
                if(qRed(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  zimg.setPixel(i,j,qRgb(255,cgreen,cblue));
                }
              }
            }
          }
         break;
        case 1:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              if(i>0&&i<w-1&&j>0&&j<h-1){
                if(qRed(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  if(qRed(zimg.pixel(i-1,j))==qGreen(zimg.pixel(i-1,j))||
                     qRed(zimg.pixel(i+1,j))==qGreen(zimg.pixel(i+1,j))||
                     qRed(zimg.pixel(i,j-1))==qGreen(zimg.pixel(i,j-1))||
                     qRed(zimg.pixel(i,j+1))==qGreen(zimg.pixel(i,j+1))){
                      zimg.setPixel(i,j,qRgb(cred,255,cblue));
                  }
                }
              }
              else{
                if(qRed(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  zimg.setPixel(i,j,qRgb(cred,255,cblue));
                }
              }
            }
          }
         break;
        case 2:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              if(i>0&&i<w-1&&j>0&&j<h-1){
                if(qBlue(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  if(qBlue(zimg.pixel(i-1,j))==qGreen(zimg.pixel(i-1,j))||
                     qBlue(zimg.pixel(i+1,j))==qGreen(zimg.pixel(i+1,j))||
                     qBlue(zimg.pixel(i,j-1))==qGreen(zimg.pixel(i,j-1))||
                     qBlue(zimg.pixel(i,j+1))==qGreen(zimg.pixel(i,j+1))){
                      zimg.setPixel(i,j,qRgb(cred,cgreen,255));
                  }
                }
              }
              else{
                if(qBlue(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  zimg.setPixel(i,j,qRgb(cred,cgreen,255));
                }
              }
            }
          }
         break;         
      }
}

// disminueix el zoom i omple la qimage
void Zoom::disminuir(rmImage &base,rmImage &mbase,int iw,int ih){
  int i,j;
  short valor,*lut;
  int  profunditat=1;
    // calcula la profunditat
    i=0;
    while(i<base.bits){
      profunditat=profunditat*2;
      i++;
    }
    // crea la lut
    lut = new short[profunditat];
    if(lut==0){
      cout << "Error al crear la lut!" << endl;
      return;
    }
    profunditat--;
    for(i=0;i<profunditat+1;i++){
      lut[i]=(byte)((double)i*(255.0/profunditat));
      if(lut[i]>255) lut[i]=255;
    }
      // inicialitza la qimage
      zimg.create(w,h,32);
      // aplica l'augment
      switch(cbase){
        case 0:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              valor=lut[base.data(i*iw,j*ih)];
              if(mbase.data(i*iw,j*ih)==0) zimg.setPixel(i,j,qRgb(valor,valor,valor));
              else zimg.setPixel(i,j,qRgb(valor,cgreen,cblue));
            }
          }
         break;
        case 1:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              valor=lut[base.data(i*iw,j*ih)];
              if(mbase.data(i*iw,j*ih)==0) zimg.setPixel(i,j,qRgb(valor,valor,valor));
              else zimg.setPixel(i,j,qRgb(cred,valor,cblue));
            }
          }
         break;
        case 2:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              valor=lut[base.data(i*iw,j*ih)];
              if(mbase.data(i*iw,j*ih)==0) zimg.setPixel(i,j,qRgb(valor,valor,valor));
              else zimg.setPixel(i,j,qRgb(cred,cgreen,valor));
            }
          }
         break;
      }
      delete lut;
      // marca el contorn
      switch(cbase){
        case 0:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              if(i>0&&i<w-1&&j>0&&j<h-1){
                if(qRed(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  if(qRed(zimg.pixel(i-1,j))==qGreen(zimg.pixel(i-1,j))||
                     qRed(zimg.pixel(i+1,j))==qGreen(zimg.pixel(i+1,j))||
                     qRed(zimg.pixel(i,j-1))==qGreen(zimg.pixel(i,j-1))||
                     qRed(zimg.pixel(i,j+1))==qGreen(zimg.pixel(i,j+1))){
                      zimg.setPixel(i,j,qRgb(255,cgreen,cblue));
                  }
                }
              }
              else{
                if(qRed(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  zimg.setPixel(i,j,qRgb(255,cgreen,cblue));
                }
              }
            }
          }
         break;
        case 1:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              if(i>0&&i<w-1&&j>0&&j<h-1){
                if(qRed(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  if(qRed(zimg.pixel(i-1,j))==qGreen(zimg.pixel(i-1,j))||
                     qRed(zimg.pixel(i+1,j))==qGreen(zimg.pixel(i+1,j))||
                     qRed(zimg.pixel(i,j-1))==qGreen(zimg.pixel(i,j-1))||
                     qRed(zimg.pixel(i,j+1))==qGreen(zimg.pixel(i,j+1))){
                      zimg.setPixel(i,j,qRgb(cred,255,cblue));
                  }
                }
              }
              else{
                if(qRed(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  zimg.setPixel(i,j,qRgb(cred,255,cblue));
                }
              }
            }
          }
         break;
        case 2:
          for(i=0;i<w;i++){
            for(j=0;j<h;j++){
              if(i>0&&i<w-1&&j>0&&j<h-1){
                if(qBlue(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  if(qBlue(zimg.pixel(i-1,j))==qGreen(zimg.pixel(i-1,j))||
                     qBlue(zimg.pixel(i+1,j))==qGreen(zimg.pixel(i+1,j))||
                     qBlue(zimg.pixel(i,j-1))==qGreen(zimg.pixel(i,j-1))||
                     qBlue(zimg.pixel(i,j+1))==qGreen(zimg.pixel(i,j+1))){
                      zimg.setPixel(i,j,qRgb(cred,cgreen,255));
                  }
                }
              }
              else{
                if(qBlue(zimg.pixel(i,j))!=qGreen(zimg.pixel(i,j))){
                  zimg.setPixel(i,j,qRgb(cred,cgreen,255));
                }
              }
            }
          }
         break;
      }
      
}

// augmenta el zoom en el 100% i passa a qimage
void Zoom::augmentar(rmImage &base,rmImage &mbase){
  int zx,zy;
      w=w*2;
      h=h*2;
      if(w>=base.dimX&&h>=base.dimY){
        zx=w/base.dimX;
        zy=h/base.dimY;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        augmentar(base,mbase,zx,zy);
        
        return;
      }
      if(w<=base.dimX&&h<=base.dimY){
        zx=base.dimX/w;
        zy=base.dimY/h;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        disminuir(base,mbase,zx,zy);
        return;
      }
}

// disminueix el zoom en el 50% i passa a qimage
void Zoom::disminuir(rmImage &base,rmImage &mbase){
  int zx,zy;
      w=w/2;
      h=h/2;
      if(w>=base.dimX&&h>=base.dimY){
        zx=w/base.dimX;
        zy=h/base.dimY;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        augmentar(base,mbase,zx,zy);
        return;
      }
      if(w<=base.dimX&&h<=base.dimY){
        zx=base.dimX/w;
        zy=base.dimY/h;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        disminuir(base,mbase,zx,zy);
        return;
      }
}

// aplica zoom i passa a qimage
void Zoom::aplicarZoom(rmImage &base,rmImage &mbase,int nw,int nh){
  int zx,zy;
      w=nw;
      h=nh;
      if(w>=base.dimX&&h>=base.dimY){
        zx=w/base.dimX;
        zy=h/base.dimY;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        augmentar(base,mbase,zx,zy);
        return;
      }
      if(w<base.dimX&&h<base.dimY){
        zx=base.dimX/w;
        zy=base.dimY/h;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        disminuir(base,mbase,zx,zy);
        return;
      }
}

void Zoom::resImg(QImage *res){
  *res=zimg.copy();
}

