/***************************************************************************
                          zoom.cpp  -  description
                             -------------------
    begin                : jue nov 7 2002
    copyright            : (C) 2002 by root
    email                : root@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "zoom.h"

Zoom::Zoom(){
   augments=1;
   xMax=-1;
   xMin=-1;
   yMax=-1;
   yMin=-1;
   dimH=-1;
   dimV=-1;
   nomesRetalla=true;
   
}
Zoom::~Zoom(){
}

Zoom & Zoom::operator = (const Zoom &z){
     w=z.w;
     h=z.h;
     wencaixat=z.wencaixat;
     hencaixat=z.hencaixat;
     dimH=z.dimH;
     dimV=z.dimV;
     augments=z.augments;
     augmentsEncaixats=z.augmentsEncaixats;
     xMax=z.xMax;
     xMin=z.xMin;
     yMax=z.yMax;
     yMin=z.yMin;
}

// augmenta donadats uns increments
void Zoom::augmentar(rmImage base,int iw,int ih){
  int i,j;
      // inicialitza la imatge
      img.resize(w, h);
      img.bits = base.bits;
      img.format = base.format;
      img.MaxValue = base.MaxValue;
      for (i=0;i<3;i++) img.voxelSize[i]= base.voxelSize[i];
      img.sliceSpacing=base.sliceSpacing;
      // aplica l'augment
      for(i=0;i<w;i++){
        for(j=0;j<h;j++){
          img.data(i,j)=base.data(i/iw,j/ih);
        }
      }
}

// augmenta donadats uns increments
void Zoom::augmentarIntel(rmImage base,int iw,int ih){
  int i,j;

      // inicialitza la imatge
      img.resize(w, h);
      img.bits = base.bits;
      img.format = base.format;
      img.MaxValue = base.MaxValue;
      for (i=0;i<3;i++) img.voxelSize[i]= base.voxelSize[i];
      img.sliceSpacing=base.sliceSpacing;
      // aplica l'augment
         for(i=0;i<w;i++){
           for(j=0;j<h;j++){
             img.data(i,j)=base.data((i / iw)+xMin, (j / ih)+yMin);
           }
         }
}

// disminueix donadats uns increments
void Zoom::disminuirIntel(rmImage base,int iw,int ih){
  int i,j;

      // inicialitza la imatge
      img.resize(w, h);
      img.bits = base.bits;
      img.format = base.format;
      img.MaxValue = base.MaxValue;
      for (i=0;i<3;i++) img.voxelSize[i]= base.voxelSize[i];
      img.sliceSpacing=base.sliceSpacing;
      // aplica la disminucio
      for(i=0;i<w;i++){
        for(j=0;j<h;j++){
          img.data(i,j)=base.data((i*iw)+xMin, (j*ih)+yMin);
        }
      }
}


// augmenta el zoom en el 100%
void Zoom::augmentarIntel(rmImage base){
  int zx,zy;

      if (xMin==-1){
         extreureMinBox (base);
         dimH=w=xMax-xMin;
         dimV=h=yMax-yMin;
         if (dimH%2!=0){
            xMax+=1;
            dimH++;
            w++;
         }
         if (dimV%2!=0){
            yMax+=1;
            dimV++;
            h++;
         }
      }

      if (!nomesRetalla){
         augments*=2;
         w=w*2;
         h=h*2;
      }
      else{
         nomesRetalla=false;
         int val=1/augments;
         if (val>1){
            w=dimH / val;
            h=dimV / val;
            disminuirIntel (base, val, val);
         }
         else
            augmentarIntel (base, augments, augments);
         
         return;
      }
      if (augments==1.0){
         disminuirIntel(base,1,1);
         w=dimH;
         h=dimV;
         return;
      }   
      if(w>=dimH && h>=dimV){
        zx=w/ dimH;
        zy=h/ dimV;
        augmentarIntel(base,zx,zy);
        return;
      }
      if(w<dimH && h<dimV){
        zx=dimH/w;
        zy=dimV/h;
        disminuirIntel(base,zx,zy);
        return;
      }
}

// disminueix el zoom en el 50%
void Zoom::disminuirIntel(rmImage base){
  int zx,zy;

      if (xMin==-1){
         extreureMinBox (base);
         dimH=w=xMax-xMin;
         dimV=h=yMax-yMin;
          if (dimH%2!=0){
            xMax+=1;
            dimH++;
            w++;
         }
         if (dimV%2!=0){
            yMax+=1;
            dimV++;
            h++;
         }
      }

      if (!nomesRetalla && w>1 && h>1){
         augments/=2;
         w=w/2;
         h=h/2;
      }
      else{
         nomesRetalla=false;
         int val=1/augments;
         if (val>0){
            w=dimH / val;
            h=dimV / val;
            disminuirIntel (base, val, val);
         }
         else
            augmentarIntel (base,augments,augments);
            
         return;
      }

      if (augments==1.0){
         disminuirIntel(base,1,1);
         w=dimH;
         h=dimV;
         return;
      }      
      if(w>=dimH && h>=dimV){
        zx=w/dimH;
        zy=h/dimV;
        augmentarIntel(base,zx,zy);
        return;
      }
      if(w<dimH && h<dimV && w>1 && h>1){
        zx=dimH/w;
        zy=dimV/h;
        disminuirIntel(base,zx,zy);
        return;
      }
}

// disminueix donadats uns increments
void Zoom::disminuir(rmImage base,int iw,int ih){
  int i,j;
      // inicialitza la imatge
      img.resize(w,h);
      img.bits = base.bits;
      img.format = base.format;
      img.MaxValue = base.MaxValue;
      for (i=0;i<3;i++) img.voxelSize[i]= base.voxelSize[i];
      img.sliceSpacing=base.sliceSpacing;
      // aplica la disminucio
      for(i=0;i<w;i++){
        for(j=0;j<h;j++){
          img.data(i,j)=base.data(i*iw,j*ih);
        }
      }
}





// augmenta el zoom en el 100%
void Zoom::augmentar(rmImage base){
  int zx,zy;
   
      augments*=2;
      w=w*2;
      h=h*2;
      if(w>=base.dimX&&h>=base.dimY){
        zx=w/base.dimX;
        zy=h/base.dimY;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        augmentar(base,zx,zy);
        return;
      }
      if(w<base.dimX&&h<base.dimY){
        zx=base.dimX/w;
        zy=base.dimY/h;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        disminuir(base,zx,zy);
        return;
      }
}

// disminueix el zoom en el 50%
void Zoom::disminuir(rmImage base){
  int zx,zy;
      augments/=2;
      w=w/2;
      h=h/2;
      if(w>=base.dimX&&h>=base.dimY){
        zx=w/base.dimX;
        zy=h/base.dimY;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        augmentar(base,zx,zy);
        return;
      }
      if(w<base.dimX&&h<base.dimY){
        zx=base.dimX/w;
        zy=base.dimY/h;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        disminuir(base,zx,zy);
        return;
      }
}

void Zoom::aplicarZoom(rmImage base,int nw,int nh){
  int zx,zy;
      w=nw;
      h=nh;
      if(w>=base.dimX&&h>=base.dimY){
        zx=w/base.dimX;
        zy=h/base.dimY;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        augmentar(base,zx,zy);
        return;
      }
      if(w<base.dimX&&h<base.dimY){
        zx=base.dimX/w;
        zy=base.dimY/h;
        if(zx==1) w=base.dimX;
        if(zy==1) h=base.dimY;
        disminuir(base,zx,zy);
        return;
      }
}

void Zoom::resImg(rmImage *res){
  *res=img;
}

void Zoom::extreureMinBox(rmImage & imatge_E){
  int et, etiq;
  xMin = imatge_E.dimX;
  yMin = imatge_E.dimY;
  xMax = 0;
  yMax = 0;

  etiq=imatge_E.data(0,0);

  for(int y=0;y<imatge_E.dimY;y++){
     for(int x=0;x<imatge_E.dimX;x++){
        et = imatge_E.data(x,y);
        if(et != etiq){
           if(x<xMin) xMin = x;
           if(y<yMin) yMin = y;
           if(x>xMax) xMax = x;
           if(y>yMax) yMax = y;
         }
      }
   }
   //per no agafar exactament la figura li donem una mica de marge
   if (xMin>0 && yMin>0 && xMax<imatge_E.dimX && yMax<imatge_E.dimY){
      xMin-=4;
      yMin-=4;
      xMax+=4;
      yMax+=4;
   }
}
