/***************************************************************************
                          docwidget.cpp  -  description
                             -------------------
    begin                : lun dic 2 2002
    copyright            : (C) 2002 by Joan
    email                : Joan@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "docwidget.h"
#include <qpainter.h>
#include <iostream.h>
#include "caract/Forma/Chang/chang.h"
#include "caract.h"
#include <qptrlist.h> 


DocWidget::DocWidget(QWidget *parent)
 : QWidget(parent) {
   AgafoPunts=FALSE;
   augments=1.0;
   enfocat=false;
   mostraPunts=false;

   coordenades *c = new coordenades;
   c->X=-1;
   llista = new ContornL;
   llista->prepend(c);
}

DocWidget::DocWidget(QWidget *parent, QImage base)
 : QWidget(parent) {
    img=base.copy();
    AgafoPunts=FALSE;
    augments=1.0;
    enfocat=false;
    mostraPunts=false;
   
  coordenades *c = new coordenades;
   c->X=-1;
  llista = new ContornL;
  llista->prepend(c);
  
}

//Cal esborrar la llista de punts
DocWidget::~DocWidget(){  
   while (llista->first()!=NULL)
      llista->removeFirst();       
}

void DocWidget::canviaImatge(QImage nova){
  img=nova.copy();
}

bool DocWidget::visualize(QImage SourceImage)
{
	bool Res;

	if(!SourceImage.isNull())
		{
        img=SourceImage;
		setBaseSize(img.width(),img.height());
		QWidget::update(0,0,img.width(),img.height());
		Res=true;
		}
	else Res=false;

	return Res;
}

void DocWidget::paintEvent(QPaintEvent *PaintEvent)
{

      QPainter Paint;
     
	Paint.begin (this);
	if(!img.isNull())
		{
            //Definim la zona que s'ha d'actualitzar de la imatge
		Paint.drawImage(PaintEvent->rect().left(),PaintEvent->rect().top(),img,
                        PaintEvent->rect().left(),PaintEvent->rect().top(),
                        PaintEvent->rect().width(),PaintEvent->rect().height());
		}
	Paint.end();
      if (mostraPunts){
      if (!llista->isEmpty()){
         QPainter Creu;
         QPen pinzell;

         coordenades obj;         

         Creu.begin(this);

         pinzell.setWidth (2);
         pinzell.setColor (QColor(qRgb(255,0,0)));
         Creu.setPen(pinzell);       

         obj=llista->first();
          while (obj.X!=-1){                                                                                                                                                                                         
            if (!enfocat){
             Creu.drawLine ((obj.X-1)*augments,(obj.Y-1)*augments,(obj.X+1)*augments,(obj.Y+1)*augments);
             Creu.drawLine ((obj.X-1)*augments,(obj.Y+1)*augments,(obj.X+1)*augments,(obj.Y-1)*augments);

//             Creu.drawPoint ((obj.X)*augments,(obj.Y)*augments);
//             Creu.drawPoint ((obj.X)*augments,(obj.Y)*augments);             
            }
            else{          
             Creu.drawLine ((obj.X-xMin-1)*augments, (obj.Y-yMin-1)*augments, (obj.X-xMin+1)*augments, (obj.Y-yMin+1)*augments);
             Creu.drawLine ((obj.X-xMin-1)*augments, (obj.Y-yMin+1)*augments, (obj.X-xMin+1)*augments, (obj.Y-yMin-1)*augments);

//             Creu.drawPoint ((obj.X-xMin)*augments, (obj.Y-yMin)*augments);
//             Creu.drawPoint ((obj.X-xMin)*augments, (obj.Y-yMin)*augments);            
            }
             
             obj=llista->next();                                                                
          }

         Creu.end();
     }
     }
}

  
void DocWidget::mousePressEvent( QMouseEvent *e){
  
coordenades *c = new coordenades;

  if (AgafoPunts){
    if (e->button()==Qt::LeftButton){
       c->X=e->x();
       c->Y=e->y();
       llista->prepend(c);

      this->update();   //Fem que es produeixi un PressEvent
      }
    else if (e->button()==Qt::RightButton){
         QMessageBox::information (this, tr("Tria el metode"), tr("Al menu forma pots escollir com tractar els punts"));
      }
    else if (e->button()==Qt::MidButton){
      if (!llista->isEmpty()){
         c=llista->first();
         if (c->X!=-1){
            llista->removeFirst();
            this->update();
         }
      }
      else
         QMessageBox::information (this, tr("STOP"), tr("No hi ha mes punts a esborrar"));
      }
  }
}

//Esborrem la llista deixant el centinella
void DocWidget::EsborrarLlista (){
   update();

   while (llista->first()->X!=-1){
      llista->removeFirst();
   }
}

