/***************************************************************************
                          linmin.cpp  -  description
                             -------------------
    begin                : Tue Sep 24 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robertmarti@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "linmin.h"
#include "f1dim.h"
#include "brent.h"
#include "mnbrak.h"

#define TOL 2.0e-4

LinMin::LinMin(){
}
LinMin::~LinMin(){
}

void LinMin::solve( rmVector<double>& p,rmVector<double>& xi,
		double& fret,rmFuncs& f )
{
    F1Dim f1dim(p, xi, f);

    double xx,xmin,fx,fb,fa,bx,ax;

    ax=0.0;
    xx=1.0;
    Mnbrak::solve(ax,xx,bx,fa,fx,fb,f1dim);
    fret=Brent::solve(ax,xx,bx,f1dim,TOL,xmin);

    xi = xi*xmin;
    p = p+xi;
}
