/***************************************************************************
                          rmhistogram.h  -  description
                             -------------------
    begin                : Tue Jul 2 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robertmarti@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RMHISTOGRAM_H
#define RMHISTOGRAM_H


/**
	One dimensional histogram class
  *@author Robert Marti
  */

#include "caract/rmlib/rmimage/rmimage.h"
#include "caract/rmlib/rmimage/rmimage3d.h"

class rmHistogram
{
public:
	long int *data, peak,NP;
	int *range;
	int N;
	double *datan;

public:
	rmHistogram(int);
	rmHistogram();
	~rmHistogram();
	void init(int);
	void create(const rmImage&);
	void create(const rmImage3d&);
	long int readPeak();
	void readRange(int [2]);
	void readRange(long *);  // for compability reasons...
	long int readValue(int);
	void normaliseHistogram();
	double readNorm(int);
	void equalise(rmImage &);
	void stretch(rmImage &);
	void getImage (rmImage &);
	
};
#endif
