/***************************************************************************
                          rmhistogram2d.h  -  description
                             -------------------
    begin                : Thu Jul 4 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robertmarti@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RMHISTOGRAM2D_H
#define RMHISTOGRAM2D_H

#include "caract/rmlib/rmimage/rmimage.h"
#include "caract/rmlib/rmimage/rmimage3d.h"

/**2D Histogram class
  *@author Robert Marti
  */

class rmHistogram2d
{
	
private:
	double **datan;
	long int range[2];
	int N,div;
	double peak,NP;

public:
	rmHistogram2d(int);
	rmHistogram2d();
	~rmHistogram2d();
	void init(int);
	void clear();
	void create(const rmImage &,const rmImage &);
	void create(const rmImage3d &,const rmImage3d&);

	void normalise();
	double readPeak();
	void readRange(long int [2]);
	double readNorm(int,int);
	void createImage(rmImage&);
	void add(int,int,double);
};


#endif
