/***************************************************************************
                          regiongrowing.h  -  description
                             -------------------
    begin                : Tue Jul 9 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robertmarti@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RMREGIONGROWING_H
#define RMREGIONGROWING_H

#include "caract/rmlib/rmimage/rmimage3d.h"
#include "caract/rmlib/rmimage/rmimage.h"
#include "caract/rmlib/rmutils/rmpoint3d.h"
#include "caract/rmlib/rmprocessing/rmstatregion.h"
#include "list.h"

/**Image segmentation using the region growing algorithm
  *@author Robert Marti
  */

class rmRegionGrowing
{
private:
	rmImage3d v3,im3,mask;
	list<rmStatRegion> stats;
	list<rmPoint3d> stack3d;
	int nSeed;
	double th;	// threshold
	int dimX,dimY,dimZ;
	
public:
	rmRegionGrowing();
	~rmRegionGrowing();
	void setThreshold(double);
	double getThreshold();
	void doRunIterative(rmImage3d &);
	void doRunIterative(rmImage &);
	/** Run region growing on a given seed point*/
	void runSeeded(rmImage3d &, rmPoint3d p);
	void runSeeded(rmImage &, rmPoint2d p);
	
//private:
	void checkIterative3d(rmStatRegion &);
	void extractMaximumVariance();

	//void updateStats(int);
	int condition1(int,rmStatRegion sr);
	int condition2(int,rmStatRegion sr);
	void processMask();
};
#endif
