/***************************************************************************
                          rmcroscor.h  -  description
                             -------------------
    begin                : Fri Jul 5 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robertmarti@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RMCROSCOR_H
#define RMCROSCOR_H

/**Cross-correlation and root mean squared error measures
  *@author Robert Marti
  */
#include "caract/rmlib/rmimage/rmimage.h"
#include "caract/rmlib/rmimage/rmimage3d.h"

class rmCross
{
public:
	rmCross();
	~rmCross();
	/** Compute Cross-correlation between two images */
	double eval(const rmImage &, const rmImage &);
	/** Compute Cross-correlation between two 3d images */
	double eval(const rmImage3d &, const rmImage3d &);
	/** Compute Root Mean Squared error between two images */
	double evalRMS(const rmImage &, const rmImage &);
	double calcMean(const rmImage &);
	double calcMean(const rmImage3d&);
};
#endif
