/***************************************************************************
                          rmmutual.cpp  -  description
                             -------------------
    begin                : Thu Jul 4 2002
    copyright            : (C) 2002 by Robert Marti
    email                : robertmarti@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "rmmutual.h"
#include <math.h>
#include "rmcomat.h"

rmMI::rmMI(int NoInt)
{
	N=NoInt;	
}


rmMI::~rmMI()
{
}

double rmMI::evalCM(const rmImage &A, const rmImage &B,int scale,int orient)
{
	rmComat cm(N);
	double angle,step,result;
	int r;

	result=0;
	step=2*M_PI/orient;
	for (r=0;r<orient;r++)
	{
		angle=step*float(r);
		cout << "CM angle "<< angle;
		cout << "CM scale "<< scale<< endl;
		cm.calc(A,B,scale,angle);
		result+= evalCM_H(cm);
		//cout << "Result "<< result<< endl;
    //if (aux1>result) result =aux1; //maximu. Comment for mean
    //cout << result<<endl;
		cm.reset();  // Reset GLCM
	}
	return result/r;
	//return EvalCM_H(cm);
}

double rmMI::evalCM_H(rmComat &cm)
{
	double aux1,aux2,aux3;
	int i,j,k,l;

	aux1=0;
	aux3=0;
	for(i=0;i<N;i++)
	  for (j=0;j<N;j++) {
			for (k=0;k<N;k++)
	      for (l=0;l<N;l++) {
					aux2=0;
					if ((cm.ca[i][j]*cm.cb[k][l])>0)
						aux2=cm.c[i][j][k][l]/(cm.ca[i][j]*cm.cb[k][l]);
					if (aux2>0)
					{
						aux1=aux1+cm.c[i][j][k][l]*log10(aux2);
						//cout <<"aux2 " << aux2<<endl;
					}
				}
				if (cm.ca[i][j]>0) aux3=aux3+cm.ca[i][j]*log10(1/cm.ca[i][j]);
	}
	cout << "aux13 "<< aux1<< " " <<aux3<<endl;
	if ((aux1==aux3)&&(aux3==0)) aux1=1;
	else aux1=aux1/aux3;
	return aux1;
}

double rmMI::evalCM2(const rmImage &A, const rmImage &B)
{
	double res;

	res=evalCM(A,B,1,4);
	res+=evalCM(A,B,2,4);
	res+=evalCM(A,B,4,4);
	res+=evalCM(A,B,8,4);
	res+=evalCM(A,B,16,4);
	return (res/5);
}

double rmMI::evalCM3(const rmImage &A, const rmImage &B)
{
	double res;

	res=evalCM(A,B,1,4);
	res+=evalCM(A,B,2,4);
	res+=evalCM(A,B,3,4);
	res+=evalCM(A,B,4,4);
	res+=evalCM(A,B,5,4);
	res+=evalCM(A,B,6,4);
	res+=evalCM(A,B,7,4);
	res+=evalCM(A,B,8,4);
	res+=evalCM(A,B,9,4);
	return (res/9);
}

double rmMI::evalCM4A(const rmImage &A, const rmImage &B)
{
	double res;

	res=evalCM(A,B,1,4);
	res+=evalCM(A,B,10,4);
	/*res=evalCM(A,B,20,4);
	res+=evalCM(A,B,25,4);
	res+=evalCM(A,B,30,4);
	res+=evalCM(A,B,35,4);
	*/
	return (res/2);
}

double rmMI::evalCM4B(const rmImage &A, const rmImage &B)
{
	double res;
	
	res=evalCM(A,B,1,4);
	res+=evalCM(A,B,10,4);
	res+=evalCM(A,B,20,4);
	res+=evalCM(A,B,25,4);
	res+=evalCM(A,B,30,4);
	res+=evalCM(A,B,35,4);
	return (res/6);
}

double rmMI::evalCMS5(const rmImage &A, const rmImage &B)
{
	double res;

	res=evalCM(A,B,1,4);
	res+=evalCM(A,B,2,4);
	res+=evalCM(A,B,3,4);
	res+=evalCM(A,B,4,4);
	res+=evalCM(A,B,5,4);
	return (res/5);
}

double rmMI::eval(const rmImage &A, const rmImage &B)
{
	rmHistogram2d pAB(N);

	pAB.create(A,B);
	return eval_H(pAB);
}

// for 3d images...
double rmMI::eval(const rmImage3d &A, const rmImage3d &B)
{
	rmHistogram2d pAB(N);

	pAB.create(A,B);
	return eval_H(pAB);
}

double rmMI::eval_H(rmHistogram2d & pAB)
{
	double *pA,*pB;
	int i,j;
	double aux1,aux2,aux3;
	pA=new double [N];
	pB=new double [N];
	// Starting grey level to be used... 0? or >0 ??
	int st=0;

	// Calculate marginal probabilities
	for (i=st;i<N;i++)
	{
	  pA[i]=0;
	  pB[i]=0;
	  for (j=st;j<N;j++)
	  {
			pA[i]+=pAB.readNorm(i,j);
			pB[i]+=pAB.readNorm(j,i);
	  }
	 }		
	aux1=0;
	aux3=0;
	aux2=0;
	for(i=st;i<N;i++)
	{
	  for (j=st;j<N;j++)
	  {
		if (((pA[i]*pB[j])>0)&&(pAB.readNorm(i,j)>0))
			aux2=pAB.readNorm(i,j)/(pA[i]*pB[j]);
		if ((aux2>0)&& (pAB.readNorm(i,j)>0))
		{	
			aux1+=pAB.readNorm(i,j)*log10(aux2);
	//		cout << aux2<<endl;
		}
	  }
	  if (pA[i]>0) aux3+=pA[i]*log10(1/pA[i]);
	 }
	if (aux3==0) aux1=0;
	else aux1=aux1/aux3;
	//aux1=aux1/aux3;	
	//cout <<"KK "<<aux1 << endl;
	delete [] pA;
	delete [] pB;

	return aux1;
}

